=== windows/ci/requirements.txt ===
pefile
pytest
