=== debian/changelog ===
hydrogen (1.2.2+dfsg-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 21 Nov 2023 09:29:51 -0800

hydrogen (1.2.2+dfsg-1) experimental; urgency=medium

  * Make use of uscan's multiple upstream tarball (MUT) to add source URL
    for upstream documentation to the watch file.
  * Enable documentation component (by default) in gbp.conf.
  * New upstream release 1.2.0+dfsg.
  * New upstream release 1.2.1+dfsg.
  * Drop 1001-patch-stats.py-with-Python-2to3.patch (no longer needed).
  * Cherry pick 0003-PortMidiDriver-now-compatible-with-PortMidi-217.patch
    from upstream.
  * Add copyright info for the new documentation source.
  * Override lintian false positive for "source-is-missing [documentation/*]".
  * Update my copyright years.
  * Build depend on itstool, so documentation can be rebuilt for DFSG
    compliance.
  * Add 0004-Define-documentation-subdir.patch.
  * Install the new localised documentation (Closes: #1040557, #1025375).
  * Update hydrogen-doc.links because the in-application documentation is now
    the newest available manual rather than the old manuals and tutorials.
  * Stop calling the ancient tutorial "new_tutorial", and install it to
    /usr/share/doc/hydrogen-doc/old_tutorial.
  * New upstream release 1.2.2+dfsg.
  * Rebase quilt series onto this release:
    - Drop 0003-PortMidiDriver-now-compatible-with-PortMidi-217.patch (contents
    already upstream).
    + Update 0004-Define-documentation-subdir.patch to work directly from the
    documentation subdir.
  * Switch from dh overrides to new style 'execute before' and 'execute_after'
    commands injected into the debhelper sequence.
  * Adapt package to upstream's migration from appdata.xml to metainfo.xml.
  * Update upstream copyright years.
  * Use local fonts only:
    + Add 0004-use-local-fonts-only.patch
    + Hydrogen-doc now needs to recommend fonts-noto-core, and fonts-b612.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 27 Oct 2023 16:40:08 -0400
