=== debian/control ===
Source: hydrogen
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Nicholas D Steeves <sten@debian.org>,
           Dennis Braun <d_braun@kabelmail.de>
Build-Depends: cmake,
               debhelper-compat (= 13),
               docbook-utils,
               itstool,
               libarchive-dev,
               libasound2-dev [linux-any],
               libcppunit-dev,
               libjack-dev,
               liblo-dev,
               liblrdf-dev,
               libportmidi-dev [linux-any],
               libpulse-dev,
               libqt5svg5-dev,
               libqt5xmlpatterns5-dev,
               libsndfile1-dev,
               libxml2-utils,
               libz-dev,
               pkg-config,
               portaudio19-dev,
               poxml,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               xmlto
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: http://www.hydrogen-music.org/
# Unfortunately, as of 2020-11-26, https://www.hydrogen-music.org/ has the
# following SSL cert issue: NET::ERR_CERT_COMMON_NAME_INVALID
# This is remains unfixed as of 2022-09-28, and was reported here:
# https://github.com/hydrogen-music/hydrogen/issues/1658
Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen

Package: hydrogen
Architecture: any
Depends: hydrogen-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         hydrogen-doc, hydrogen-drumkits, rubberband-cli
Suggests: ladspa-plugin
Breaks: hydrogen-data (<< 1.0.1-2)
Replaces: hydrogen-data (<< 1.0.1-2)
Description: advanced drum machine/step sequencer
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 General features:
  * Very user-friendly, modular, fast and intuitive graphical interface
    based on Qt 5.
  * Sample-based stereo audio engine, with import of sound samples in
    .wav, .au and .aiff formats.
  * Support of samples in compressed FLAC file.
 .
 Sequencer and mixer features:
  * Pattern-based sequencer, with unlimited number of patterns and
    ability to chain patterns into a song.
  * Up to 64 ticks per pattern with individual level per event and
    variable pattern length.
  * 32 instrument tracks with volume, mute, solo, pan capabilities.
  * Multi layer support for instruments (up to 16 samples for each
    instrument).
  * Ability to import/export song files.
  * Unique human velocity, human time, pitch and swing functions.
  * Multiple patterns playing at once.
 .
 Other features:
  * JACK, ALSA, PortAudio, OSS and PulseAudio audio drivers.
  * ALSA MIDI and PortMidi input with assignable midi-in channel (1..16,
    ALL).
  * Import/export of drumkits.
  * Export song to wav file.
  * Export song to midi file.

Package: hydrogen-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: hydrogen
Breaks: hydrogen (<< 0.9.7-5~)
Replaces: hydrogen (<< 0.9.7-5~)
Description: advanced drum machine/step sequencer (data)
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 This package contains the architecture-independent data files.

Package: hydrogen-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fonts-b612, fonts-noto-core
Breaks: hydrogen (<< 0.9.7-1~)
Replaces: hydrogen (<< 0.9.7-1~)
Description: advanced drum machine/step sequencer (doc)
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 This package contains the architecture-independent documentation.
