=== debian/changelog ===
hydrogen (1.2.3+dfsg-0.1~mx23+1) mx; urgency=medium

  * New upstream release 1.2.3+dfsg.
  * Refresh patches.
  * Don't install usr/share/hydrogen/data/doc.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 16 Jan 2024 06:52:03 -0800

hydrogen (1.2.2+dfsg-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 21 Nov 2023 09:29:51 -0800
