=== debian/rules ===
--- 
+++ 
@@ -26,3 +26,5 @@
 # No dbgsym packages:
 override_dh_strip:
 	dh_strip --no-automatic-dbgsym
+
+override_dh_installman:
